Cell[][] cells;     
int cellSize = 10;  
int numX, numY;     

void setup() { 
  frameRate(10);
  size(500, 300);
  numX = floor(width/cellSize);
  numY = floor(height/cellSize);
  startup();
} 


void draw() {
  background(200);
            
  for (int x = 0; x < numX; x++) {
    for (int y = 0; y < numY; y++) {
     cells[x][y].compNextState();
    }
  }             
            
  for (int x = 0; x < numX; x++) {
    for (int y = 0; y < numY; y++) {
     cells[x][y].drawMe();
    }
  }
}

void startup() {
  // creo la griglia di celle
  cells = new Cell[numX][numY];  
  for (int x = 0; x < numX; x++) {
    for (int y = 0; y < numY; y++) {  
      cells[x][y] = new Cell(x, y);     
    }        
  }          
  // assegno i vicini ad ogni cella 
  for (int x = 0; x < numX; x++) {
    for (int y = 0; y < numY; y++) {  
      int above = y-1;    
      int below = y+1;    
      int left = x-1;      
      int right = x+1;      
      if (above < 0) above = numY-1;   
      if (below == numY) below = 0;  
      if (left < 0) left = numX-1;  
      if (right == numX) right = 0;  

      cells[x][y].addNeighbour(cells[left][above]);  
      cells[x][y].addNeighbour(cells[left][y]);    
      cells[x][y].addNeighbour(cells[left][below]);  
      cells[x][y].addNeighbour(cells[x][below]);  
      cells[x][y].addNeighbour(cells[right][below]);  
      cells[x][y].addNeighbour(cells[right][y]);  
      cells[x][y].addNeighbour(cells[right][above]);  
      cells[x][y].addNeighbour(cells[x][above]);    
    }
  }
}


void mousePressed() {
  startup();
}

class Cell {
  float x, y;
  boolean state;  
  boolean nextState;  
  Cell[] neighbours;
  
  Cell(float _x, float _y) {
    x = _x * cellSize;
    y = _y * cellSize;
    if (random(2) > 1) {  
      nextState = true;
    } else {
      nextState = false; 
    }
    state = nextState;
    neighbours = new Cell[0];
  }
  
  void addNeighbour(Cell cell) {
    neighbours = (Cell[]) append(neighbours, cell); 
  }
  
  void compNextState() { 
    // conto i vicini vivi
    int liveCount = 0;    
    for (int i=0; i < neighbours.length; i++) {
       if (neighbours[i].state == true) {  
         liveCount++;      
       }        
     }
    // se sono vivo e ho non troppi vicini vivi (2 o 3) rimango vivo, altrimenti muoio 
    if (state == true) {         
        if ((liveCount == 2) || (liveCount == 3)) {  
          nextState = true;          
        } else {            
          nextState = false;        
        } 
     // se sono morto e ho 3 vicini vivi, ritorno vivo         
     } else {            
        if (liveCount == 3) {        
          nextState = true;      
        } else {        
          nextState = false;    
        }        
     }       
  }

  void drawMe() {
    state = nextState;
    noStroke();
    if (state == true) {
      fill(0);
    } else {
      fill(255);
    }
    rect(x, y, cellSize, cellSize);
  }
  
}