/* 
* Disegna 100 spirali ellittiche 
*/
float a; // semiasse maggiore dell'ellisse
float b; // semiasse minore dell'ellisse
float stepa, stepb; // incrementi degli assi
float lastx, lasty, x, y; // coordinate precedenti e correnti
float noi; // rumore di Perlin 
float variance; // varianza degli assi
float startAngle; // angolo iniziale
float endAngle;   // angolo finale
float stepAngle;  // incremento dell'angolo

void setup() {
  fullScreen();
  //size(500, 500); 
  background(255);
  smooth(); 


  variance = 200;
  stepa = 0.5;
  stepb = 0.5;
  for (int i=0; i < 100; i++) {
    a = 10;
    b = 10;
    strokeWeight(random(2));
    noi = random(10);
    color col = color(random(200), random(200), random(200));
    float trasp = random(200);
    stroke(col, trasp);
  
    startAngle = radians(random(360));
    endAngle = radians(360 * 4 + random(360 * 4));
    stepAngle = radians(random(3, 8));

    x = width/2  + a * cos(startAngle);
    y = height/2 + b * sin(startAngle);

    drawSpiral();
  }
}

void drawSpiral() {

  float mya, myb;
  
  for (float alpha = startAngle; alpha < endAngle; alpha += stepAngle) {
    
    lastx = x;
    lasty = y;  

    mya = a + (noise(noi) - 0.5) * variance;
    myb = b + (noise(noi) - 0.5) * variance;
    
    // calcolo le coordinate di un punto sull'ellisse
    x = width/2 +  mya * cos(alpha);
    y = height/2 + myb * sin(alpha);
  
    // unisco con una linea il punto corrente e quello precedente
    line(x, y, lastx, lasty);
  
    // incremento gli assi dell'ellisse
    a = a + stepa;
    b = b + stepb;
    
    // incremento il seme del rumore di Perlin
    noi = noi + 0.05;
  }
}

void draw() {}

void mouseReleased() {
  save("Keplero.gif");
}  